import json

import requests  # type: ignore
from aiogram import F, Router
from aiogram.filters import Command
from aiogram.fsm.context import FSMContext
from aiogram.fsm.state import State, StatesGroup
from aiogram.types import Message

router = Router()


class OrderAsk(StatesGroup):
    string = State()


@router.message(Command('ask'))
async def reverse_request(message: Message, state: FSMContext):
    await state.set_state(OrderAsk.string)
    await message.answer(
        text='Введите вопрос',
    )


@router.message(OrderAsk.string, F.text)
async def reversing(message: Message, state: FSMContext):
    string = message.text
    if string is not None:
        pass
    data = {'question_raw': [string]}

    response = requests.post(
        url='https://7012.deeppavlov.ai/model', data=json.dumps(data)
    )

    if response.status_code == 200:
        response = response.json()
        answer = response[0][0]
        accuracy = round(response[0][1], 2)
        if not answer:
            await message.answer(text='На этот вопрос я не могу дать ответ')
        else:
            await message.answer(text=f'Ответ: {answer}\nТочность: {accuracy}')
    else:
        await message.answer(f'Request error: status code is {response.status_code}')
    await state.clear()
