from aiogram import F, Router
from aiogram.filters import Command
from aiogram.fsm.context import FSMContext
from aiogram.fsm.state import State, StatesGroup
from aiogram.types import Message
from aiogram.utils.markdown import hbold

router = Router()

greatings = ['привет', 'добрый день', 'добрый вечер', 'доброе утро', 'здравствуйте']


# Класс сохнранения состояний FSM
class OrderReverse(StatesGroup):
    string = State()


@router.message(Command('reverse'))
async def reverse_request(message: Message, state: FSMContext):
    """По комманде /reverse активизирует контекст запроса"""
    await state.set_state(OrderReverse.string)
    await message.answer(
        text='Введите строку для разворота',
    )


@router.message(OrderReverse.string, F.text)
async def reversing(message: Message, state: FSMContext):
    """В контексте запроса получает введенную строку из диалога
    и возвращает ее в развернутом виде"""
    string = message.text
    if string is not None:
        string = string[::-1]
    await message.answer(
        text=f'Ваша строка наоборот:\n{string}',
    )
    await state.clear()


@router.message(F.text.func(lambda m: m.lower() in greatings))
async def greating(message: Message):
    """Сробатывает по фильтру при вхождении полученного текста в списке"""
    await message.answer(f'Здравствуй, {hbold(message.from_user.first_name)}')
